
#include "Atomic/robbery/robberyADVISE.h"


robberyADVISE::robberyADVISE() {
  DoNothingAD.setParent(this);
  WritedownaccountinformationAD.setParent(this);
  ImpersonatecustomertoobtainmoneyAD.setParent(this);
  DoNothingOutcome1.setParent(this);
  WritedownaccountinformationSuccess.setParent(this);
  ImpersonatecustomertoobtainmoneyFailure.setParent(this);
  ImpersonatecustomertoobtainmoneySuccess.setParent(this);
  ImpersonatecustomertoobtainmoneyGroup.initialize(2, "ImpersonatecustomertoobtainmoneyGroup");
  ImpersonatecustomertoobtainmoneyGroup.appendGroup((BaseGroupClass*) &ImpersonatecustomertoobtainmoneyFailure);
  ImpersonatecustomertoobtainmoneyGroup.appendGroup((BaseGroupClass*) &ImpersonatecustomertoobtainmoneySuccess);

  AdversaryDecisionGroup.initialize(3, "AdversaryDecisionGroup");
  AdversaryDecisionGroup.appendGroup((BaseGroupClass*) &DoNothingAD);
  AdversaryDecisionGroup.appendGroup((BaseGroupClass*) &WritedownaccountinformationAD);
  AdversaryDecisionGroup.appendGroup((BaseGroupClass*) &ImpersonatecustomertoobtainmoneyAD);

  BaseADVISEAction* InitialActions[7] = {
    &DoNothingAD, // 0
    &WritedownaccountinformationAD, // 1
    &ImpersonatecustomertoobtainmoneyAD, // 2
    &DoNothingOutcome1, // 3
    &WritedownaccountinformationSuccess, // 4
    &ImpersonatecustomertoobtainmoneyFailure, // 5
    &ImpersonatecustomertoobtainmoneySuccess // 6
  };

  Step* InitialSteps[4] = {
      &DoNothingOutcome1,
      &WritedownaccountinformationSuccess,
      &ImpersonatecustomertoobtainmoneyFailure,
      &ImpersonatecustomertoobtainmoneySuccess
  };

  BaseGroupClass* InitialGroups[4] = {
    (BaseGroupClass*) &DoNothingOutcome1, // 0
    (BaseGroupClass*) &WritedownaccountinformationSuccess, // 1
    (BaseGroupClass*) &ImpersonatecustomertoobtainmoneyGroup, // 2
    (BaseGroupClass*) &AdversaryDecisionGroup
  };

  InsiderKnowledge = new Knowledge("InsiderKnowledge", 1);
  CustomerInformation = new Knowledge("CustomerInformation", 0);
  Money = new Goal("Money", 0);
  Money->setPayoff(1000);
  MakeDecision = new BeginAdversaryDecision("MakeDecision", 0);
  DoNothingWeight = new StepWeight("DoNothingWeight", 0);
  DoNothingChosen = new StepChosen("DoNothingChosen", 0);
  WritedownaccountinformationWeight = new StepWeight("WritedownaccountinformationWeight", 0);
  WritedownaccountinformationChosen = new StepChosen("WritedownaccountinformationChosen", 0);
  ImpersonatecustomertoobtainmoneyWeight = new StepWeight("ImpersonatecustomertoobtainmoneyWeight", 0);
  ImpersonatecustomertoobtainmoneyChosen = new StepChosen("ImpersonatecustomertoobtainmoneyChosen", 0);

  Goal* InitialGoals[1] = {
      Money
  };

  ADVISEStateVariable* InitialSVs[10] = {
    InsiderKnowledge, // 0
    CustomerInformation, // 1
    Money, // 2
    DoNothingChosen, // 3
    WritedownaccountinformationChosen, // 4
    ImpersonatecustomertoobtainmoneyChosen, // 5
    DoNothingWeight, // 6
    WritedownaccountinformationWeight, // 7
    ImpersonatecustomertoobtainmoneyWeight, // 8
    MakeDecision // 9
};

  int outCounts[3] = { 1, 1, 2 };

  commonInit("robbery", 10, InitialSVs, 7, InitialActions, 4, InitialGroups, 3, outCounts, InitialSteps, 1, InitialGoals);

  advCostPref = 0.0;
  advDetectPref = 0.2;
  advPayPref = 0.8;

  planningHorizon = 2;
  costDiscount = 1.0;
  detectionDiscount = 1.0;
  payoffDiscount = 1.0;

  assignSVsToAttackSteps();

  int AffectArcs[35][2] = {
    {9,0}, {3,0}, {6,0}, {9,1}, {4,1}, {7,1}, {9,2}, {5,2}, 
    {8,2}, {9,3}, {3,3}, {6,3}, {7,3}, {8,3}, {9,4}, {4,4}, 
    {6,4}, {7,4}, {8,4}, {1,4}, {0,4}, {9,5}, {5,5}, {6,5}, 
    {7,5}, {8,5}, {1,5}, {2,5}, {9,6}, {5,6}, {6,6}, {7,6}, 
    {8,6}, {1,6}, {2,6}
};
  for(int n = 0; n < 35;n++)
    AddAffectArc(InitialSVs[AffectArcs[n][0]], InitialActions[AffectArcs[n][1]]);
  int EnableArcs[10][2] = {
    {9,0}, {9,1}, {9,2}, {3,3}, {4,4}, {1,4}, {5,5}, {2,5}, 
    {5,6}, {2,6}
};
  for(int n = 0; n < 10;n++)
    AddEnableArc(InitialSVs[EnableArcs[n][0]], InitialActions[EnableArcs[n][1]]);
  for(int x = 0; x < 7; x++) {
    InitialActions[x]->LinkVariables();
  }

  customInitialization();

  recalculateAdversaryDecisionWeights();

}

robberyADVISE::~robberyADVISE() {
}

void robberyADVISE::assignSVsToAttackSteps() {
  DoNothingOutcome1.DoNothingChosen = DoNothingChosen;
  DoNothingOutcome1.DoNothingWeight = DoNothingWeight;
  DoNothingOutcome1.WritedownaccountinformationWeight = WritedownaccountinformationWeight;
  DoNothingOutcome1.ImpersonatecustomertoobtainmoneyWeight = ImpersonatecustomertoobtainmoneyWeight;
  DoNothingOutcome1.MakeDecision = MakeDecision;
  DoNothingOutcome1.setSVs(DoNothingChosen, DoNothingWeight);
  WritedownaccountinformationSuccess.CustomerInformation = CustomerInformation;
  WritedownaccountinformationSuccess.InsiderKnowledge = InsiderKnowledge;
  WritedownaccountinformationSuccess.WritedownaccountinformationChosen = WritedownaccountinformationChosen;
  WritedownaccountinformationSuccess.DoNothingWeight = DoNothingWeight;
  WritedownaccountinformationSuccess.WritedownaccountinformationWeight = WritedownaccountinformationWeight;
  WritedownaccountinformationSuccess.ImpersonatecustomertoobtainmoneyWeight = ImpersonatecustomertoobtainmoneyWeight;
  WritedownaccountinformationSuccess.MakeDecision = MakeDecision;
  WritedownaccountinformationSuccess.setSVs(WritedownaccountinformationChosen, WritedownaccountinformationWeight);
  ImpersonatecustomertoobtainmoneyFailure.CustomerInformation = CustomerInformation;
  ImpersonatecustomertoobtainmoneyFailure.Money = Money;
  ImpersonatecustomertoobtainmoneyFailure.ImpersonatecustomertoobtainmoneyChosen = ImpersonatecustomertoobtainmoneyChosen;
  ImpersonatecustomertoobtainmoneyFailure.DoNothingWeight = DoNothingWeight;
  ImpersonatecustomertoobtainmoneyFailure.WritedownaccountinformationWeight = WritedownaccountinformationWeight;
  ImpersonatecustomertoobtainmoneyFailure.ImpersonatecustomertoobtainmoneyWeight = ImpersonatecustomertoobtainmoneyWeight;
  ImpersonatecustomertoobtainmoneyFailure.MakeDecision = MakeDecision;
  ImpersonatecustomertoobtainmoneyFailure.setSVs(ImpersonatecustomertoobtainmoneyChosen, ImpersonatecustomertoobtainmoneyWeight);
  ImpersonatecustomertoobtainmoneySuccess.CustomerInformation = CustomerInformation;
  ImpersonatecustomertoobtainmoneySuccess.Money = Money;
  ImpersonatecustomertoobtainmoneySuccess.ImpersonatecustomertoobtainmoneyChosen = ImpersonatecustomertoobtainmoneyChosen;
  ImpersonatecustomertoobtainmoneySuccess.DoNothingWeight = DoNothingWeight;
  ImpersonatecustomertoobtainmoneySuccess.WritedownaccountinformationWeight = WritedownaccountinformationWeight;
  ImpersonatecustomertoobtainmoneySuccess.ImpersonatecustomertoobtainmoneyWeight = ImpersonatecustomertoobtainmoneyWeight;
  ImpersonatecustomertoobtainmoneySuccess.MakeDecision = MakeDecision;
  ImpersonatecustomertoobtainmoneySuccess.setSVs(ImpersonatecustomertoobtainmoneyChosen, ImpersonatecustomertoobtainmoneyWeight);

  DoNothingAD.MakeDecision = MakeDecision;
  DoNothingAD.DoNothingChosen = DoNothingChosen;
  DoNothingAD.DoNothingWeight = DoNothingWeight;
  WritedownaccountinformationAD.MakeDecision = MakeDecision;
  WritedownaccountinformationAD.WritedownaccountinformationChosen = WritedownaccountinformationChosen;
  WritedownaccountinformationAD.WritedownaccountinformationWeight = WritedownaccountinformationWeight;
  ImpersonatecustomertoobtainmoneyAD.MakeDecision = MakeDecision;
  ImpersonatecustomertoobtainmoneyAD.ImpersonatecustomertoobtainmoneyChosen = ImpersonatecustomertoobtainmoneyChosen;
  ImpersonatecustomertoobtainmoneyAD.ImpersonatecustomertoobtainmoneyWeight = ImpersonatecustomertoobtainmoneyWeight;
}

double robberyADVISE::convertCostToUtility(double cost) {
  const double esquared = 7.389056099; // e^(2)
  if(cost < 0)
    return 1.0;
  else if(cost > 100)
    return 0.0;
  else {
    return (esquared - exp(cost/50))/(-1 + esquared);
  }
}

double robberyADVISE::convertPayoffToUtility(double payoff) {
  const double etoten = 28.031624895; // e^(10/3)
  if(payoff < 0)
    return 0;
  else if(payoff > 1000)
    return 1;
  else {
    return (etoten - (etoten/exp(payoff/300)))/(-1 + etoten);
  }
}

double robberyADVISE::convertDetectionToUtility(double detection) {
  const double esquared = 7.389056099; // e^(2)
  if(detection < 0)
    return 1;
  else if(detection > 1)
    return 0;
  else {
    return (1-(esquared/exp(2*detection)))/(1-esquared);
  }
}

void robberyADVISE::customInitialization() {

}

/*****************************************************************/
/*                   Attack Step Definitions                     */
/*****************************************************************/

/*====================== DoNothingOutcome1Step ========================*/

robberyADVISE::DoNothingOutcome1Step::DoNothingOutcome1Step() {
  TheDistributionParameters = new double[1];
  commonInit("DoNothingOutcome1Step", 0, Deterministic, RaceEnabled, 5, 0, false);}

robberyADVISE::DoNothingOutcome1Step::~DoNothingOutcome1Step() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::DoNothingOutcome1Step::LinkVariables() {
  DoNothingChosen->Register(&DoNothingChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WritedownaccountinformationWeight->Register(&WritedownaccountinformationWeight_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyWeight->Register(&ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::DoNothingOutcome1Step::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(DoNothingChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::DoNothingOutcome1Step::timeDistributionParameter0() {
return 1;
}

double robberyADVISE::DoNothingOutcome1Step::Weight() {
  return 1;
}

bool robberyADVISE::DoNothingOutcome1Step::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::DoNothingOutcome1Step::ReactivationFunction() {
  return false;
}

double robberyADVISE::DoNothingOutcome1Step::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::DoNothingOutcome1Step::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::DoNothingOutcome1Step::Rank() {
  return 1;
}

bool robberyADVISE::DoNothingOutcome1Step::preconditionsMet() {

  return true;
}

void robberyADVISE::DoNothingOutcome1Step::executeEffects() {

}

double robberyADVISE::DoNothingOutcome1Step::getCost() {
return 0;
}

double robberyADVISE::DoNothingOutcome1Step::getOutcomeProbability() {
return 1;
}

double robberyADVISE::DoNothingOutcome1Step::getDetection() {
return 0;
}

/*====================== WritedownaccountinformationSuccessStep ========================*/

robberyADVISE::WritedownaccountinformationSuccessStep::WritedownaccountinformationSuccessStep() {
  TheDistributionParameters = new double[1];
  commonInit("WritedownaccountinformationSuccessStep", 1, Deterministic, RaceEnabled, 7, 1, false);}

robberyADVISE::WritedownaccountinformationSuccessStep::~WritedownaccountinformationSuccessStep() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::WritedownaccountinformationSuccessStep::LinkVariables() {
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  InsiderKnowledge->Register(&InsiderKnowledge_Mobius_Mark);
  WritedownaccountinformationChosen->Register(&WritedownaccountinformationChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WritedownaccountinformationWeight->Register(&WritedownaccountinformationWeight_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyWeight->Register(&ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::WritedownaccountinformationSuccessStep::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(WritedownaccountinformationChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::WritedownaccountinformationSuccessStep::timeDistributionParameter0() {
return 5;
}

double robberyADVISE::WritedownaccountinformationSuccessStep::Weight() {
  return 1;
}

bool robberyADVISE::WritedownaccountinformationSuccessStep::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::WritedownaccountinformationSuccessStep::ReactivationFunction() {
  return false;
}

double robberyADVISE::WritedownaccountinformationSuccessStep::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::WritedownaccountinformationSuccessStep::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::WritedownaccountinformationSuccessStep::Rank() {
  return 1;
}

bool robberyADVISE::WritedownaccountinformationSuccessStep::preconditionsMet() {
return (!CustomerInformation->Mark() && InsiderKnowledge->Mark());
  return true;
}

void robberyADVISE::WritedownaccountinformationSuccessStep::executeEffects() {
CustomerInformation->Mark() = true;
}

double robberyADVISE::WritedownaccountinformationSuccessStep::getCost() {
return 0;
}

double robberyADVISE::WritedownaccountinformationSuccessStep::getOutcomeProbability() {
return 1;
}

double robberyADVISE::WritedownaccountinformationSuccessStep::getDetection() {
return 0.1;
}

/*====================== ImpersonatecustomertoobtainmoneyFailureStep ========================*/

robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::ImpersonatecustomertoobtainmoneyFailureStep() {
  TheDistributionParameters = new double[1];
  commonInit("ImpersonatecustomertoobtainmoneyFailureStep", 2, Deterministic, RaceEnabled, 7, 1, false);}

robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::~ImpersonatecustomertoobtainmoneyFailureStep() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::LinkVariables() {
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  Money->Register(&Money_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyChosen->Register(&ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WritedownaccountinformationWeight->Register(&WritedownaccountinformationWeight_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyWeight->Register(&ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::timeDistributionParameter0() {
return 10;
}

double robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::Weight() {
return 0.3;
}

bool robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::ReactivationFunction() {
  return false;
}

double robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::Rank() {
  return 1;
}

bool robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::preconditionsMet() {
return CustomerInformation->Mark() && !Money->Mark();
  return true;
}

void robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::executeEffects() {

}

double robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::getCost() {
return 0;
}

double robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::getOutcomeProbability() {
return 0.3;
}

double robberyADVISE::ImpersonatecustomertoobtainmoneyFailureStep::getDetection() {
return 0.9;
}

/*====================== ImpersonatecustomertoobtainmoneySuccessStep ========================*/

robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::ImpersonatecustomertoobtainmoneySuccessStep() {
  TheDistributionParameters = new double[1];
  commonInit("ImpersonatecustomertoobtainmoneySuccessStep", 2, Deterministic, RaceEnabled, 7, 1, false);}

robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::~ImpersonatecustomertoobtainmoneySuccessStep() {
  delete[] TheDistributionParameters;
}

void robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::LinkVariables() {
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  Money->Register(&Money_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyChosen->Register(&ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  WritedownaccountinformationWeight->Register(&WritedownaccountinformationWeight_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyWeight->Register(&ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::timeDistributionParameter0() {
return 10;
}

double robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::Weight() {
return 0.7;
}

bool robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::ReactivationFunction() {
  return false;
}

double robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::Rank() {
  return 1;
}

bool robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::preconditionsMet() {
return CustomerInformation->Mark() && !Money->Mark();
  return true;
}

void robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::executeEffects() {
Money->Mark() = true;
}

double robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::getCost() {
return 0;
}

double robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::getOutcomeProbability() {
return 0.7;
}

double robberyADVISE::ImpersonatecustomertoobtainmoneySuccessStep::getDetection() {
return 0;
}

/*****************************************************************/
/*                   Adversary Decisions                         */
/*****************************************************************/

/*====================== DoNothingAdversaryDecision ========================*/

robberyADVISE::DoNothingAdversaryDecision::DoNothingAdversaryDecision() {
  commonInit("DoNothingAdversaryDecision", 3, Instantaneous, RaceEnabled, 2, 1, false);
}

robberyADVISE::DoNothingAdversaryDecision::~DoNothingAdversaryDecision() {
}

void robberyADVISE::DoNothingAdversaryDecision::LinkVariables() {
  MakeDecision->Register(&MakeDecision_Mobius_Mark);
  DoNothingChosen->Register(&DoNothingChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
}

bool robberyADVISE::DoNothingAdversaryDecision::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(MakeDecision_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::DoNothingAdversaryDecision::Weight() {
  return DoNothingWeight->Mark();
}

bool robberyADVISE::DoNothingAdversaryDecision::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::DoNothingAdversaryDecision::ReactivationFunction() {
  return false;
}

double robberyADVISE::DoNothingAdversaryDecision::SampleDistribution() {
  return 0;
}

double* robberyADVISE::DoNothingAdversaryDecision::ReturnDistributionParameters() {
  return NULL;
}

int robberyADVISE::DoNothingAdversaryDecision::Rank() {
  return 1;
}

BaseActionClass* robberyADVISE::DoNothingAdversaryDecision::Fire() {
  (*(MakeDecision_Mobius_Mark))--;
  (*(DoNothingWeight_Mobius_Mark))--;
  (*(DoNothingChosen_Mobius_Mark))++;
  return this;
}

/*====================== WritedownaccountinformationAdversaryDecision ========================*/

robberyADVISE::WritedownaccountinformationAdversaryDecision::WritedownaccountinformationAdversaryDecision() {
  commonInit("WritedownaccountinformationAdversaryDecision", 3, Instantaneous, RaceEnabled, 2, 1, false);
}

robberyADVISE::WritedownaccountinformationAdversaryDecision::~WritedownaccountinformationAdversaryDecision() {
}

void robberyADVISE::WritedownaccountinformationAdversaryDecision::LinkVariables() {
  MakeDecision->Register(&MakeDecision_Mobius_Mark);
  WritedownaccountinformationChosen->Register(&WritedownaccountinformationChosen_Mobius_Mark);
  WritedownaccountinformationWeight->Register(&WritedownaccountinformationWeight_Mobius_Mark);
}

bool robberyADVISE::WritedownaccountinformationAdversaryDecision::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(MakeDecision_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::WritedownaccountinformationAdversaryDecision::Weight() {
  return WritedownaccountinformationWeight->Mark();
}

bool robberyADVISE::WritedownaccountinformationAdversaryDecision::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::WritedownaccountinformationAdversaryDecision::ReactivationFunction() {
  return false;
}

double robberyADVISE::WritedownaccountinformationAdversaryDecision::SampleDistribution() {
  return 0;
}

double* robberyADVISE::WritedownaccountinformationAdversaryDecision::ReturnDistributionParameters() {
  return NULL;
}

int robberyADVISE::WritedownaccountinformationAdversaryDecision::Rank() {
  return 1;
}

BaseActionClass* robberyADVISE::WritedownaccountinformationAdversaryDecision::Fire() {
  (*(MakeDecision_Mobius_Mark))--;
  (*(WritedownaccountinformationWeight_Mobius_Mark))--;
  (*(WritedownaccountinformationChosen_Mobius_Mark))++;
  return this;
}

/*====================== ImpersonatecustomertoobtainmoneyAdversaryDecision ========================*/

robberyADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::ImpersonatecustomertoobtainmoneyAdversaryDecision() {
  commonInit("ImpersonatecustomertoobtainmoneyAdversaryDecision", 3, Instantaneous, RaceEnabled, 2, 1, false);
}

robberyADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::~ImpersonatecustomertoobtainmoneyAdversaryDecision() {
}

void robberyADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::LinkVariables() {
  MakeDecision->Register(&MakeDecision_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyChosen->Register(&ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyWeight->Register(&ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark);
}

bool robberyADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(MakeDecision_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robberyADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::Weight() {
  return ImpersonatecustomertoobtainmoneyWeight->Mark();
}

bool robberyADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::ReactivationPredicate() {
  return false;
}

bool robberyADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::ReactivationFunction() {
  return false;
}

double robberyADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::SampleDistribution() {
  return 0;
}

double* robberyADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::ReturnDistributionParameters() {
  return NULL;
}

int robberyADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::Rank() {
  return 1;
}

BaseActionClass* robberyADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::Fire() {
  (*(MakeDecision_Mobius_Mark))--;
  (*(ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark))--;
  (*(ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark))++;
  return this;
}

