#ifndef robberyADVISE_H_
#define robberyADVISE_H_

#include "Cpp/Simulator/UserDistributions.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/atomic/advise/ADVISEModel.h"
#include "Cpp/BaseClasses/atomic/advise/Access.h"
#include "Cpp/BaseClasses/atomic/advise/AdversaryDecision.h"
#include "Cpp/BaseClasses/atomic/advise/BeginAdversaryDecision.h"
#include "Cpp/BaseClasses/atomic/advise/Goal.h"
#include "Cpp/BaseClasses/atomic/advise/Knowledge.h"
#include "Cpp/BaseClasses/atomic/advise/Skill.h"
#include "Cpp/BaseClasses/atomic/advise/Step.h"
#include "Cpp/BaseClasses/atomic/advise/StepChosen.h"
#include "Cpp/BaseClasses/atomic/advise/StepWeight.h"
#include <limits.h>
#include <math.h>
extern UserDistributions* TheDistribution;

/*********************************************************************
               robberyADVISE Submodel Definition                   
*********************************************************************/

class robberyADVISE : public ADVISEModel {
public:

class DoNothingAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  StepChosen *DoNothingChosen;
  short *DoNothingChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  double *TheDistributionParameters;

  DoNothingAdversaryDecision();
  ~DoNothingAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // DoNothingAdversaryDecision

class WritedownaccountinformationAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  StepChosen *WritedownaccountinformationChosen;
  short *WritedownaccountinformationChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  double *TheDistributionParameters;

  WritedownaccountinformationAdversaryDecision();
  ~WritedownaccountinformationAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // WritedownaccountinformationAdversaryDecision

class ImpersonatecustomertoobtainmoneyAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  StepChosen *ImpersonatecustomertoobtainmoneyChosen;
  short *ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonatecustomertoobtainmoneyAdversaryDecision();
  ~ImpersonatecustomertoobtainmoneyAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // ImpersonatecustomertoobtainmoneyAdversaryDecision

class DoNothingOutcome1Step : public Step {
public:

  StepChosen *DoNothingChosen;
  short *DoNothingChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  DoNothingOutcome1Step();
  ~DoNothingOutcome1Step();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // DoNothingOutcome1Step

class WritedownaccountinformationSuccessStep : public Step {
public:

  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  Knowledge *InsiderKnowledge;
  short* InsiderKnowledge_Mobius_Mark;
  StepChosen *WritedownaccountinformationChosen;
  short *WritedownaccountinformationChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  WritedownaccountinformationSuccessStep();
  ~WritedownaccountinformationSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // WritedownaccountinformationSuccessStep

class ImpersonatecustomertoobtainmoneyFailureStep : public Step {
public:

  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  Goal *Money;
  short* Money_Mobius_Mark;
  StepChosen *ImpersonatecustomertoobtainmoneyChosen;
  short *ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonatecustomertoobtainmoneyFailureStep();
  ~ImpersonatecustomertoobtainmoneyFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // ImpersonatecustomertoobtainmoneyFailureStep

class ImpersonatecustomertoobtainmoneySuccessStep : public Step {
public:

  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  Goal *Money;
  short* Money_Mobius_Mark;
  StepChosen *ImpersonatecustomertoobtainmoneyChosen;
  short *ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonatecustomertoobtainmoneySuccessStep();
  ~ImpersonatecustomertoobtainmoneySuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // ImpersonatecustomertoobtainmoneySuccessStep

  //List of user-specified state variables
  Knowledge *InsiderKnowledge;
  Knowledge *CustomerInformation;
  Goal *Money;
  //List of attack step weight state variables
  StepWeight *DoNothingWeight;
  StepWeight *WritedownaccountinformationWeight;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  //List of attack step chosen state variables
  StepChosen *DoNothingChosen;
  StepChosen *WritedownaccountinformationChosen;
  StepChosen *ImpersonatecustomertoobtainmoneyChosen;
  //List of attack steps
  DoNothingOutcome1Step DoNothingOutcome1;
  WritedownaccountinformationSuccessStep WritedownaccountinformationSuccess;
  ImpersonatecustomertoobtainmoneyFailureStep ImpersonatecustomertoobtainmoneyFailure;
  ImpersonatecustomertoobtainmoneySuccessStep ImpersonatecustomertoobtainmoneySuccess;
  DoNothingAdversaryDecision DoNothingAD;
  WritedownaccountinformationAdversaryDecision WritedownaccountinformationAD;
  ImpersonatecustomertoobtainmoneyAdversaryDecision ImpersonatecustomertoobtainmoneyAD;
  //Groups for attack steps
  PreselectGroup ImmediateGroup;
  PostselectGroup ImpersonatecustomertoobtainmoneyGroup;
  PostselectGroup AdversaryDecisionGroup;
  robberyADVISE();
  ~robberyADVISE();
  void assignSVsToAttackSteps();
  double convertCostToUtility(double cost);
  double convertDetectionToUtility(double detections);
  double convertPayoffToUtility(double payoff);
  void customInitialization();

protected:
}; // end robberyADVISE

#endif // robberyADVISE_H_
