
#include "Atomic/robbery2/robbery2ADVISE.h"
#include <stdlib.h>
#include <iostream>
#include <math.h>


robbery2ADVISE::robbery2ADVISE() {
  WritedownaccountinformationAD.setParent(this);
  DoNothingAD.setParent(this);
  ImpersonatecustomertoobtainmoneyAD.setParent(this);
  WritedownaccountinformationSuccess.setParent(this);
  DoNothingOutcome1.setParent(this);
  ImpersonatecustomertoobtainmoneyFailure.setParent(this);
  ImpersonatecustomertoobtainmoneySuccess.setParent(this);
  ImpersonatecustomertoobtainmoneyGroup.initialize(2, "ImpersonatecustomertoobtainmoneyGroup");
  ImpersonatecustomertoobtainmoneyGroup.appendGroup((BaseGroupClass*) &ImpersonatecustomertoobtainmoneyFailure);
  ImpersonatecustomertoobtainmoneyGroup.appendGroup((BaseGroupClass*) &ImpersonatecustomertoobtainmoneySuccess);

  AdversaryDecisionGroup.initialize(3, "AdversaryDecisionGroup");
  AdversaryDecisionGroup.appendGroup((BaseGroupClass*) &WritedownaccountinformationAD);
  AdversaryDecisionGroup.appendGroup((BaseGroupClass*) &DoNothingAD);
  AdversaryDecisionGroup.appendGroup((BaseGroupClass*) &ImpersonatecustomertoobtainmoneyAD);

  BaseADVISEAction* InitialActions[7] = {
    &WritedownaccountinformationAD, // 0
    &DoNothingAD, // 1
    &ImpersonatecustomertoobtainmoneyAD, // 2
    &WritedownaccountinformationSuccess, // 3
    &DoNothingOutcome1, // 4
    &ImpersonatecustomertoobtainmoneyFailure, // 5
    &ImpersonatecustomertoobtainmoneySuccess // 6
  };

  Step* InitialSteps[4] = {
      &WritedownaccountinformationSuccess,
      &DoNothingOutcome1,
      &ImpersonatecustomertoobtainmoneyFailure,
      &ImpersonatecustomertoobtainmoneySuccess
  };

  BaseGroupClass* InitialGroups[4] = {
    (BaseGroupClass*) &WritedownaccountinformationSuccess, // 0
    (BaseGroupClass*) &DoNothingOutcome1, // 1
    (BaseGroupClass*) &ImpersonatecustomertoobtainmoneyGroup, // 2
    (BaseGroupClass*) &AdversaryDecisionGroup
  };

  TellerAccess = new Access("TellerAccess", 1);
  InsiderKnowledge = new Knowledge("InsiderKnowledge", 0);
  CustomerInformation = new Knowledge("CustomerInformation", 0);
  SneakySkill = new Skill("SneakySkill", 0);
  Money = new Goal("Money", 0);
  Money->setPayoff();
  MakeDecision = new BeginAdversaryDecision("MakeDecision", 0);
  WritedownaccountinformationWeight = new StepWeight("WritedownaccountinformationWeight", 0);
  WritedownaccountinformationChosen = new StepChosen("WritedownaccountinformationChosen", 0);
  DoNothingWeight = new StepWeight("DoNothingWeight", 0);
  DoNothingChosen = new StepChosen("DoNothingChosen", 0);
  ImpersonatecustomertoobtainmoneyWeight = new StepWeight("ImpersonatecustomertoobtainmoneyWeight", 0);
  ImpersonatecustomertoobtainmoneyChosen = new StepChosen("ImpersonatecustomertoobtainmoneyChosen", 0);

  Goal* InitialGoals[1] = {
      Money
  };

  ADVISEStateVariable* InitialSVs[12] = {
    TellerAccess, // 0
    InsiderKnowledge, // 1
    CustomerInformation, // 2
    SneakySkill, // 3
    Money, // 4
    WritedownaccountinformationChosen, // 5
    DoNothingChosen, // 6
    ImpersonatecustomertoobtainmoneyChosen, // 7
    WritedownaccountinformationWeight, // 8
    DoNothingWeight, // 9
    ImpersonatecustomertoobtainmoneyWeight, // 10
    MakeDecision // 11
};

  int outCounts[3] = { 1, 1, 2 };

  commonInit("robbery2", 12, InitialSVs, 7, InitialActions, 4, InitialGroups, 3, outCounts, InitialSteps, 1, InitialGoals);

  advCostPref = 0.0;
  advDetectPref = 0.2;
  advPayPref = 0.8;

  planningHorizon = 2;
  costDiscount = 1.0;
  detectionDiscount = 1.0;
  payoffDiscount = 1.0;

  assignSVsToAttackSteps();

  int AffectArcs[36][2] = {
    {11,0}, {5,0}, {8,0}, {11,1}, {6,1}, {9,1}, {11,2}, {7,2}, 
    {10,2}, {11,3}, {5,3}, {8,3}, {9,3}, {10,3}, {2,3}, {1,3}, 
    {0,3}, {11,4}, {6,4}, {8,4}, {9,4}, {10,4}, {11,5}, {7,5}, 
    {8,5}, {9,5}, {10,5}, {4,5}, {2,5}, {11,6}, {7,6}, {8,6}, 
    {9,6}, {10,6}, {4,6}, {2,6}
};
  for(int n = 0; n < 36;n++)
    AddAffectArc(InitialSVs[AffectArcs[n][0]], InitialActions[AffectArcs[n][1]]);
  int EnableArcs[10][2] = {
    {11,0}, {11,1}, {11,2}, {5,3}, {2,3}, {6,4}, {7,5}, {4,5}, 
    {7,6}, {4,6}
};
  for(int n = 0; n < 10;n++)
    AddEnableArc(InitialSVs[EnableArcs[n][0]], InitialActions[EnableArcs[n][1]]);
  for(int x = 0; x < 7; x++) {
    InitialActions[x]->LinkVariables();
  }

  customInitialization();

  recalculateAdversaryDecisionWeights();

}

robbery2ADVISE::~robbery2ADVISE() {
}

void robbery2ADVISE::assignSVsToAttackSteps() {
  WritedownaccountinformationSuccess.CustomerInformation = CustomerInformation;
  WritedownaccountinformationSuccess.InsiderKnowledge = InsiderKnowledge;
  WritedownaccountinformationSuccess.SneakySkill = SneakySkill;
  WritedownaccountinformationSuccess.TellerAccess = TellerAccess;
  WritedownaccountinformationSuccess.WritedownaccountinformationChosen = WritedownaccountinformationChosen;
  WritedownaccountinformationSuccess.WritedownaccountinformationWeight = WritedownaccountinformationWeight;
  WritedownaccountinformationSuccess.DoNothingWeight = DoNothingWeight;
  WritedownaccountinformationSuccess.ImpersonatecustomertoobtainmoneyWeight = ImpersonatecustomertoobtainmoneyWeight;
  WritedownaccountinformationSuccess.MakeDecision = MakeDecision;
  WritedownaccountinformationSuccess.setSVs(WritedownaccountinformationChosen, WritedownaccountinformationWeight);
  DoNothingOutcome1.DoNothingChosen = DoNothingChosen;
  DoNothingOutcome1.WritedownaccountinformationWeight = WritedownaccountinformationWeight;
  DoNothingOutcome1.DoNothingWeight = DoNothingWeight;
  DoNothingOutcome1.ImpersonatecustomertoobtainmoneyWeight = ImpersonatecustomertoobtainmoneyWeight;
  DoNothingOutcome1.MakeDecision = MakeDecision;
  DoNothingOutcome1.setSVs(DoNothingChosen, DoNothingWeight);
  ImpersonatecustomertoobtainmoneyFailure.Money = Money;
  ImpersonatecustomertoobtainmoneyFailure.CustomerInformation = CustomerInformation;
  ImpersonatecustomertoobtainmoneyFailure.ImpersonatecustomertoobtainmoneyChosen = ImpersonatecustomertoobtainmoneyChosen;
  ImpersonatecustomertoobtainmoneyFailure.WritedownaccountinformationWeight = WritedownaccountinformationWeight;
  ImpersonatecustomertoobtainmoneyFailure.DoNothingWeight = DoNothingWeight;
  ImpersonatecustomertoobtainmoneyFailure.ImpersonatecustomertoobtainmoneyWeight = ImpersonatecustomertoobtainmoneyWeight;
  ImpersonatecustomertoobtainmoneyFailure.MakeDecision = MakeDecision;
  ImpersonatecustomertoobtainmoneyFailure.setSVs(ImpersonatecustomertoobtainmoneyChosen, ImpersonatecustomertoobtainmoneyWeight);
  ImpersonatecustomertoobtainmoneySuccess.Money = Money;
  ImpersonatecustomertoobtainmoneySuccess.CustomerInformation = CustomerInformation;
  ImpersonatecustomertoobtainmoneySuccess.ImpersonatecustomertoobtainmoneyChosen = ImpersonatecustomertoobtainmoneyChosen;
  ImpersonatecustomertoobtainmoneySuccess.WritedownaccountinformationWeight = WritedownaccountinformationWeight;
  ImpersonatecustomertoobtainmoneySuccess.DoNothingWeight = DoNothingWeight;
  ImpersonatecustomertoobtainmoneySuccess.ImpersonatecustomertoobtainmoneyWeight = ImpersonatecustomertoobtainmoneyWeight;
  ImpersonatecustomertoobtainmoneySuccess.MakeDecision = MakeDecision;
  ImpersonatecustomertoobtainmoneySuccess.setSVs(ImpersonatecustomertoobtainmoneyChosen, ImpersonatecustomertoobtainmoneyWeight);

  WritedownaccountinformationAD.MakeDecision = MakeDecision;
  WritedownaccountinformationAD.WritedownaccountinformationChosen = WritedownaccountinformationChosen;
  WritedownaccountinformationAD.WritedownaccountinformationWeight = WritedownaccountinformationWeight;
  DoNothingAD.MakeDecision = MakeDecision;
  DoNothingAD.DoNothingChosen = DoNothingChosen;
  DoNothingAD.DoNothingWeight = DoNothingWeight;
  ImpersonatecustomertoobtainmoneyAD.MakeDecision = MakeDecision;
  ImpersonatecustomertoobtainmoneyAD.ImpersonatecustomertoobtainmoneyChosen = ImpersonatecustomertoobtainmoneyChosen;
  ImpersonatecustomertoobtainmoneyAD.ImpersonatecustomertoobtainmoneyWeight = ImpersonatecustomertoobtainmoneyWeight;
}

double robbery2ADVISE::convertCostToUtility(double cost) {
  const double esquared = 7.389056099; // e^(2)
  if(cost < 0)
    return 1.0;
  else if(cost > 100)
    return 0.0;
  else {
    return (esquared - exp(cost/50))/(-1 + esquared);
  }
}

double robbery2ADVISE::convertPayoffToUtility(double payoff) {
  const double etoten = 28.031624895; // e^(10/3)
  if(payoff < 0)
    return 0;
  else if(payoff > 1000)
    return 1;
  else {
    return (etoten - (etoten/exp(payoff/300)))/(-1 + etoten);
  }
}

double robbery2ADVISE::convertDetectionToUtility(double detection) {
  const double esquared = 7.389056099; // e^(2)
  if(detection < 0)
    return 1;
  else if(detection > 1)
    return 0;
  else {
    return (1-(esquared/exp(2*detection)))/(1-esquared);
  }
}

void robbery2ADVISE::customInitialization() {
InsiderKnowledge->Mark() = hasInsiderKnowledge;
}

/*****************************************************************/
/*                   Attack Step Definitions                     */
/*****************************************************************/

/*====================== WritedownaccountinformationSuccessStep ========================*/

robbery2ADVISE::WritedownaccountinformationSuccessStep::WritedownaccountinformationSuccessStep() {
  TheDistributionParameters = new double[1];
  commonInit("WritedownaccountinformationSuccessStep", 0, Deterministic, RaceEnabled, 9, 1, false);}

robbery2ADVISE::WritedownaccountinformationSuccessStep::~WritedownaccountinformationSuccessStep() {
  delete[] TheDistributionParameters;
}

void robbery2ADVISE::WritedownaccountinformationSuccessStep::LinkVariables() {
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  InsiderKnowledge->Register(&InsiderKnowledge_Mobius_Mark);
  SneakySkill->Register(&SneakySkill_Mobius_Mark);
  TellerAccess->Register(&TellerAccess_Mobius_Mark);
  WritedownaccountinformationChosen->Register(&WritedownaccountinformationChosen_Mobius_Mark);
  WritedownaccountinformationWeight->Register(&WritedownaccountinformationWeight_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyWeight->Register(&ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robbery2ADVISE::WritedownaccountinformationSuccessStep::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(WritedownaccountinformationChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robbery2ADVISE::WritedownaccountinformationSuccessStep::timeDistributionParameter0() {
return 5;
}

double robbery2ADVISE::WritedownaccountinformationSuccessStep::Weight() {
  return 1;
}

bool robbery2ADVISE::WritedownaccountinformationSuccessStep::ReactivationPredicate() {
  return false;
}

bool robbery2ADVISE::WritedownaccountinformationSuccessStep::ReactivationFunction() {
  return false;
}

double robbery2ADVISE::WritedownaccountinformationSuccessStep::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robbery2ADVISE::WritedownaccountinformationSuccessStep::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robbery2ADVISE::WritedownaccountinformationSuccessStep::Rank() {
  return 1;
}

bool robbery2ADVISE::WritedownaccountinformationSuccessStep::preconditionsMet() {
return !CustomerInformation->Mark() && TellerAccess->Mark() 
      && (InsiderKnowledge->Mark() || SneakySkill->Mark() >500);
  return true;
}

void robbery2ADVISE::WritedownaccountinformationSuccessStep::executeEffects() {
CustomerInformation->Mark() = true;
}

double robbery2ADVISE::WritedownaccountinformationSuccessStep::getCost() {
return 0;
}

double robbery2ADVISE::WritedownaccountinformationSuccessStep::getOutcomeProbability() {
return 1;
}

double robbery2ADVISE::WritedownaccountinformationSuccessStep::getDetection() {
return 0.1;
}

/*====================== DoNothingOutcome1Step ========================*/

robbery2ADVISE::DoNothingOutcome1Step::DoNothingOutcome1Step() {
  TheDistributionParameters = new double[1];
  commonInit("DoNothingOutcome1Step", 1, Deterministic, RaceEnabled, 5, 0, false);}

robbery2ADVISE::DoNothingOutcome1Step::~DoNothingOutcome1Step() {
  delete[] TheDistributionParameters;
}

void robbery2ADVISE::DoNothingOutcome1Step::LinkVariables() {
  DoNothingChosen->Register(&DoNothingChosen_Mobius_Mark);
  WritedownaccountinformationWeight->Register(&WritedownaccountinformationWeight_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyWeight->Register(&ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robbery2ADVISE::DoNothingOutcome1Step::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(DoNothingChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robbery2ADVISE::DoNothingOutcome1Step::timeDistributionParameter0() {
return 1;
}

double robbery2ADVISE::DoNothingOutcome1Step::Weight() {
  return 1;
}

bool robbery2ADVISE::DoNothingOutcome1Step::ReactivationPredicate() {
  return false;
}

bool robbery2ADVISE::DoNothingOutcome1Step::ReactivationFunction() {
  return false;
}

double robbery2ADVISE::DoNothingOutcome1Step::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robbery2ADVISE::DoNothingOutcome1Step::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robbery2ADVISE::DoNothingOutcome1Step::Rank() {
  return 1;
}

bool robbery2ADVISE::DoNothingOutcome1Step::preconditionsMet() {

  return true;
}

void robbery2ADVISE::DoNothingOutcome1Step::executeEffects() {

}

double robbery2ADVISE::DoNothingOutcome1Step::getCost() {
return 0;
}

double robbery2ADVISE::DoNothingOutcome1Step::getOutcomeProbability() {
return 1;
}

double robbery2ADVISE::DoNothingOutcome1Step::getDetection() {
return 0;
}

/*====================== ImpersonatecustomertoobtainmoneyFailureStep ========================*/

robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::ImpersonatecustomertoobtainmoneyFailureStep() {
  TheDistributionParameters = new double[1];
  commonInit("ImpersonatecustomertoobtainmoneyFailureStep", 2, Deterministic, RaceEnabled, 7, 1, false);}

robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::~ImpersonatecustomertoobtainmoneyFailureStep() {
  delete[] TheDistributionParameters;
}

void robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::LinkVariables() {
  Money->Register(&Money_Mobius_Mark);
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyChosen->Register(&ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark);
  WritedownaccountinformationWeight->Register(&WritedownaccountinformationWeight_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyWeight->Register(&ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::timeDistributionParameter0() {
return 10;
}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::Weight() {
return 0.3;
}

bool robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::ReactivationPredicate() {
  return false;
}

bool robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::ReactivationFunction() {
  return false;
}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::Rank() {
  return 1;
}

bool robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::preconditionsMet() {
return CustomerInformation->Mark() && !Money->Mark();
  return true;
}

void robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::executeEffects() {

}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::getCost() {
return 0;
}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::getOutcomeProbability() {
return 0.3;
}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneyFailureStep::getDetection() {
return 0.9;
}

/*====================== ImpersonatecustomertoobtainmoneySuccessStep ========================*/

robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::ImpersonatecustomertoobtainmoneySuccessStep() {
  TheDistributionParameters = new double[1];
  commonInit("ImpersonatecustomertoobtainmoneySuccessStep", 2, Deterministic, RaceEnabled, 7, 1, false);}

robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::~ImpersonatecustomertoobtainmoneySuccessStep() {
  delete[] TheDistributionParameters;
}

void robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::LinkVariables() {
  Money->Register(&Money_Mobius_Mark);
  CustomerInformation->Register(&CustomerInformation_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyChosen->Register(&ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark);
  WritedownaccountinformationWeight->Register(&WritedownaccountinformationWeight_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyWeight->Register(&ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark);
  MakeDecision->Register(&MakeDecision_Mobius_Mark);

}

bool robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::timeDistributionParameter0() {
return 10;
}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::Weight() {
return 0.7;
}

bool robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::ReactivationPredicate() {
  return false;
}

bool robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::ReactivationFunction() {
  return false;
}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::SampleDistribution() {
  return TheDistribution->Deterministic(timeDistributionParameter0());
}

double *robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::ReturnDistributionParameters() {
  TheDistributionParameters[0] = timeDistributionParameter0();
  return TheDistributionParameters;
}

int robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::Rank() {
  return 1;
}

bool robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::preconditionsMet() {
return CustomerInformation->Mark() && !Money->Mark();
  return true;
}

void robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::executeEffects() {
Money->Mark() = true;
}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::getCost() {
return 0;
}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::getOutcomeProbability() {
return 0.7;
}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneySuccessStep::getDetection() {
return 0;
}

/*****************************************************************/
/*                   Adversary Decisions                         */
/*****************************************************************/

/*====================== WritedownaccountinformationAdversaryDecision ========================*/

robbery2ADVISE::WritedownaccountinformationAdversaryDecision::WritedownaccountinformationAdversaryDecision() {
  commonInit("WritedownaccountinformationAdversaryDecision", 3, Instantaneous, RaceEnabled, 2, 1, false);
}

robbery2ADVISE::WritedownaccountinformationAdversaryDecision::~WritedownaccountinformationAdversaryDecision() {
}

void robbery2ADVISE::WritedownaccountinformationAdversaryDecision::LinkVariables() {
  MakeDecision->Register(&MakeDecision_Mobius_Mark);
  WritedownaccountinformationChosen->Register(&WritedownaccountinformationChosen_Mobius_Mark);
  WritedownaccountinformationWeight->Register(&WritedownaccountinformationWeight_Mobius_Mark);
}

bool robbery2ADVISE::WritedownaccountinformationAdversaryDecision::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(MakeDecision_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robbery2ADVISE::WritedownaccountinformationAdversaryDecision::Weight() {
  return WritedownaccountinformationWeight->Mark();
}

bool robbery2ADVISE::WritedownaccountinformationAdversaryDecision::ReactivationPredicate() {
  return false;
}

bool robbery2ADVISE::WritedownaccountinformationAdversaryDecision::ReactivationFunction() {
  return false;
}

double robbery2ADVISE::WritedownaccountinformationAdversaryDecision::SampleDistribution() {
  return 0;
}

double* robbery2ADVISE::WritedownaccountinformationAdversaryDecision::ReturnDistributionParameters() {
  return NULL;
}

int robbery2ADVISE::WritedownaccountinformationAdversaryDecision::Rank() {
  return 1;
}

BaseActionClass* robbery2ADVISE::WritedownaccountinformationAdversaryDecision::Fire() {
  (*(MakeDecision_Mobius_Mark))--;
  (*(WritedownaccountinformationWeight_Mobius_Mark))--;
  (*(WritedownaccountinformationChosen_Mobius_Mark))++;
  return this;
}

/*====================== DoNothingAdversaryDecision ========================*/

robbery2ADVISE::DoNothingAdversaryDecision::DoNothingAdversaryDecision() {
  commonInit("DoNothingAdversaryDecision", 3, Instantaneous, RaceEnabled, 2, 1, false);
}

robbery2ADVISE::DoNothingAdversaryDecision::~DoNothingAdversaryDecision() {
}

void robbery2ADVISE::DoNothingAdversaryDecision::LinkVariables() {
  MakeDecision->Register(&MakeDecision_Mobius_Mark);
  DoNothingChosen->Register(&DoNothingChosen_Mobius_Mark);
  DoNothingWeight->Register(&DoNothingWeight_Mobius_Mark);
}

bool robbery2ADVISE::DoNothingAdversaryDecision::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(MakeDecision_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robbery2ADVISE::DoNothingAdversaryDecision::Weight() {
  return DoNothingWeight->Mark();
}

bool robbery2ADVISE::DoNothingAdversaryDecision::ReactivationPredicate() {
  return false;
}

bool robbery2ADVISE::DoNothingAdversaryDecision::ReactivationFunction() {
  return false;
}

double robbery2ADVISE::DoNothingAdversaryDecision::SampleDistribution() {
  return 0;
}

double* robbery2ADVISE::DoNothingAdversaryDecision::ReturnDistributionParameters() {
  return NULL;
}

int robbery2ADVISE::DoNothingAdversaryDecision::Rank() {
  return 1;
}

BaseActionClass* robbery2ADVISE::DoNothingAdversaryDecision::Fire() {
  (*(MakeDecision_Mobius_Mark))--;
  (*(DoNothingWeight_Mobius_Mark))--;
  (*(DoNothingChosen_Mobius_Mark))++;
  return this;
}

/*====================== ImpersonatecustomertoobtainmoneyAdversaryDecision ========================*/

robbery2ADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::ImpersonatecustomertoobtainmoneyAdversaryDecision() {
  commonInit("ImpersonatecustomertoobtainmoneyAdversaryDecision", 3, Instantaneous, RaceEnabled, 2, 1, false);
}

robbery2ADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::~ImpersonatecustomertoobtainmoneyAdversaryDecision() {
}

void robbery2ADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::LinkVariables() {
  MakeDecision->Register(&MakeDecision_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyChosen->Register(&ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark);
  ImpersonatecustomertoobtainmoneyWeight->Register(&ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark);
}

bool robbery2ADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::Enabled() {
  OldEnabled = NewEnabled;
  NewEnabled = (((*(MakeDecision_Mobius_Mark)) >= 1));
  return NewEnabled;
}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::Weight() {
  return ImpersonatecustomertoobtainmoneyWeight->Mark();
}

bool robbery2ADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::ReactivationPredicate() {
  return false;
}

bool robbery2ADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::ReactivationFunction() {
  return false;
}

double robbery2ADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::SampleDistribution() {
  return 0;
}

double* robbery2ADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::ReturnDistributionParameters() {
  return NULL;
}

int robbery2ADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::Rank() {
  return 1;
}

BaseActionClass* robbery2ADVISE::ImpersonatecustomertoobtainmoneyAdversaryDecision::Fire() {
  (*(MakeDecision_Mobius_Mark))--;
  (*(ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark))--;
  (*(ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark))++;
  return this;
}

