#ifndef robbery2ADVISE_H_
#define robbery2ADVISE_H_

#include "Simulator/UserDistributions.h"
#include "BaseClasses/GlobalVariables.h"
#include "BaseClasses/PostselectGroup.h"
#include "BaseClasses/PreselectGroup.h"
#include "BaseClasses/atomic/advise/ADVISEModel.h"
#include "BaseClasses/atomic/advise/Access.h"
#include "BaseClasses/atomic/advise/AdversaryDecision.h"
#include "BaseClasses/atomic/advise/BeginAdversaryDecision.h"
#include "BaseClasses/atomic/advise/Goal.h"
#include "BaseClasses/atomic/advise/Knowledge.h"
#include "BaseClasses/atomic/advise/Skill.h"
#include "BaseClasses/atomic/advise/Step.h"
#include "BaseClasses/atomic/advise/StepChosen.h"
#include "BaseClasses/atomic/advise/StepWeight.h"
#include <limits.h>
#include <math.h>
extern Short hasInsiderKnowledge;
extern Short sneakySkillProf;
extern UserDistributions* TheDistribution;

/*********************************************************************
               robbery2ADVISE Submodel Definition                   
*********************************************************************/

class robbery2ADVISE : public ADVISEModel {
public:

class WritedownaccountinformationAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  StepChosen *WritedownaccountinformationChosen;
  short *WritedownaccountinformationChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  double *TheDistributionParameters;

  WritedownaccountinformationAdversaryDecision();
  ~WritedownaccountinformationAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // WritedownaccountinformationAdversaryDecision

class DoNothingAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  StepChosen *DoNothingChosen;
  short *DoNothingChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  double *TheDistributionParameters;

  DoNothingAdversaryDecision();
  ~DoNothingAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // DoNothingAdversaryDecision

class ImpersonatecustomertoobtainmoneyAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  StepChosen *ImpersonatecustomertoobtainmoneyChosen;
  short *ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonatecustomertoobtainmoneyAdversaryDecision();
  ~ImpersonatecustomertoobtainmoneyAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // ImpersonatecustomertoobtainmoneyAdversaryDecision

class WritedownaccountinformationSuccessStep : public Step {
public:

  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  Knowledge *InsiderKnowledge;
  short* InsiderKnowledge_Mobius_Mark;
  Skill *SneakySkill;
  short* SneakySkill_Mobius_Mark;
  Access *TellerAccess;
  short* TellerAccess_Mobius_Mark;
  StepChosen *WritedownaccountinformationChosen;
  short *WritedownaccountinformationChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  WritedownaccountinformationSuccessStep();
  ~WritedownaccountinformationSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // WritedownaccountinformationSuccessStep

class DoNothingOutcome1Step : public Step {
public:

  StepChosen *DoNothingChosen;
  short *DoNothingChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  DoNothingOutcome1Step();
  ~DoNothingOutcome1Step();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // DoNothingOutcome1Step

class ImpersonatecustomertoobtainmoneyFailureStep : public Step {
public:

  Goal *Money;
  short* Money_Mobius_Mark;
  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  StepChosen *ImpersonatecustomertoobtainmoneyChosen;
  short *ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonatecustomertoobtainmoneyFailureStep();
  ~ImpersonatecustomertoobtainmoneyFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // ImpersonatecustomertoobtainmoneyFailureStep

class ImpersonatecustomertoobtainmoneySuccessStep : public Step {
public:

  Goal *Money;
  short* Money_Mobius_Mark;
  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  StepChosen *ImpersonatecustomertoobtainmoneyChosen;
  short *ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonatecustomertoobtainmoneySuccessStep();
  ~ImpersonatecustomertoobtainmoneySuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // ImpersonatecustomertoobtainmoneySuccessStep

  //List of user-specified state variables
  Access *TellerAccess;
  Knowledge *InsiderKnowledge;
  Knowledge *CustomerInformation;
  Skill *SneakySkill;
  Goal *Money;
  //List of attack step weight state variables
  StepWeight *WritedownaccountinformationWeight;
  StepWeight *DoNothingWeight;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  //List of attack step chosen state variables
  StepChosen *WritedownaccountinformationChosen;
  StepChosen *DoNothingChosen;
  StepChosen *ImpersonatecustomertoobtainmoneyChosen;
  //List of attack steps
  WritedownaccountinformationSuccessStep WritedownaccountinformationSuccess;
  DoNothingOutcome1Step DoNothingOutcome1;
  ImpersonatecustomertoobtainmoneyFailureStep ImpersonatecustomertoobtainmoneyFailure;
  ImpersonatecustomertoobtainmoneySuccessStep ImpersonatecustomertoobtainmoneySuccess;
  WritedownaccountinformationAdversaryDecision WritedownaccountinformationAD;
  DoNothingAdversaryDecision DoNothingAD;
  ImpersonatecustomertoobtainmoneyAdversaryDecision ImpersonatecustomertoobtainmoneyAD;
  //Groups for attack steps
  PreselectGroup ImmediateGroup;
  PostselectGroup ImpersonatecustomertoobtainmoneyGroup;
  PostselectGroup AdversaryDecisionGroup;
  robbery2ADVISE();
  ~robbery2ADVISE();
  void assignSVsToAttackSteps();
  double convertCostToUtility(double cost);
  double convertDetectionToUtility(double detections);
  double convertPayoffToUtility(double payoff);
  void customInitialization();

protected:
}; // end robbery2ADVISE

#endif // robbery2ADVISE_H_
