#ifndef robbery3ADVISE_H_
#define robbery3ADVISE_H_

#include "Simulator/UserDistributions.h"
#include "BaseClasses/GlobalVariables.h"
#include "BaseClasses/PostselectGroup.h"
#include "BaseClasses/PreselectGroup.h"
#include "BaseClasses/atomic/advise/ADVISEModel.h"
#include "BaseClasses/atomic/advise/Access.h"
#include "BaseClasses/atomic/advise/AdversaryDecision.h"
#include "BaseClasses/atomic/advise/BeginAdversaryDecision.h"
#include "BaseClasses/atomic/advise/Goal.h"
#include "BaseClasses/atomic/advise/Knowledge.h"
#include "BaseClasses/atomic/advise/Skill.h"
#include "BaseClasses/atomic/advise/Step.h"
#include "BaseClasses/atomic/advise/StepChosen.h"
#include "BaseClasses/atomic/advise/StepWeight.h"
#include <limits.h>
#include <math.h>
extern Short hasInsiderKnowledge;
extern Short sneakySkillProf;
extern UserDistributions* TheDistribution;

/*********************************************************************
               robbery3ADVISE Submodel Definition                   
*********************************************************************/

class robbery3ADVISE : public ADVISEModel {
public:

class WritedownaccountinformationAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  StepChosen *WritedownaccountinformationChosen;
  short *WritedownaccountinformationChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  double *TheDistributionParameters;

  WritedownaccountinformationAdversaryDecision();
  ~WritedownaccountinformationAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // WritedownaccountinformationAdversaryDecision

class ImpersonatecustomertoobtainmoneyAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  StepChosen *ImpersonatecustomertoobtainmoneyChosen;
  short *ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonatecustomertoobtainmoneyAdversaryDecision();
  ~ImpersonatecustomertoobtainmoneyAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // ImpersonatecustomertoobtainmoneyAdversaryDecision

class DoNothingAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  StepChosen *DoNothingChosen;
  short *DoNothingChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  double *TheDistributionParameters;

  DoNothingAdversaryDecision();
  ~DoNothingAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // DoNothingAdversaryDecision

class DistractManagerWithPhonyPhoneCallAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  StepChosen *DistractManagerWithPhonyPhoneCallChosen;
  short *DistractManagerWithPhonyPhoneCallChosen_Mobius_Mark;
  StepWeight *DistractManagerWithPhonyPhoneCallWeight;
  short *DistractManagerWithPhonyPhoneCallWeight_Mobius_Mark;
  double *TheDistributionParameters;

  DistractManagerWithPhonyPhoneCallAdversaryDecision();
  ~DistractManagerWithPhonyPhoneCallAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // DistractManagerWithPhonyPhoneCallAdversaryDecision

class WritedownaccountinformationSuccessStep : public Step {
public:

  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  Knowledge *InsiderKnowledge;
  short* InsiderKnowledge_Mobius_Mark;
  Skill *SneakySkill;
  short* SneakySkill_Mobius_Mark;
  Access *TellerAccess;
  short* TellerAccess_Mobius_Mark;
  StepChosen *WritedownaccountinformationChosen;
  short *WritedownaccountinformationChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *DistractManagerWithPhonyPhoneCallWeight;
  short *DistractManagerWithPhonyPhoneCallWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  WritedownaccountinformationSuccessStep();
  ~WritedownaccountinformationSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // WritedownaccountinformationSuccessStep

class ImpersonatecustomertoobtainmoneyFailureStep : public Step {
public:

  Goal *Money;
  short* Money_Mobius_Mark;
  Access *TellerAccess;
  short* TellerAccess_Mobius_Mark;
  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  Access *ManagerOffDuty;
  short* ManagerOffDuty_Mobius_Mark;
  StepChosen *ImpersonatecustomertoobtainmoneyChosen;
  short *ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *DistractManagerWithPhonyPhoneCallWeight;
  short *DistractManagerWithPhonyPhoneCallWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonatecustomertoobtainmoneyFailureStep();
  ~ImpersonatecustomertoobtainmoneyFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // ImpersonatecustomertoobtainmoneyFailureStep

class ImpersonatecustomertoobtainmoneySuccessStep : public Step {
public:

  Goal *Money;
  short* Money_Mobius_Mark;
  Access *TellerAccess;
  short* TellerAccess_Mobius_Mark;
  Knowledge *CustomerInformation;
  short* CustomerInformation_Mobius_Mark;
  Access *ManagerOffDuty;
  short* ManagerOffDuty_Mobius_Mark;
  StepChosen *ImpersonatecustomertoobtainmoneyChosen;
  short *ImpersonatecustomertoobtainmoneyChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *DistractManagerWithPhonyPhoneCallWeight;
  short *DistractManagerWithPhonyPhoneCallWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  ImpersonatecustomertoobtainmoneySuccessStep();
  ~ImpersonatecustomertoobtainmoneySuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // ImpersonatecustomertoobtainmoneySuccessStep

class DoNothingOutcome1Step : public Step {
public:

  StepChosen *DoNothingChosen;
  short *DoNothingChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *DistractManagerWithPhonyPhoneCallWeight;
  short *DistractManagerWithPhonyPhoneCallWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  DoNothingOutcome1Step();
  ~DoNothingOutcome1Step();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // DoNothingOutcome1Step

class DistractManagerWithPhonyPhoneCallFailureManagerDetectsFraudStep : public Step {
public:

  Access *ManagerOffDuty;
  short* ManagerOffDuty_Mobius_Mark;
  Knowledge *ManagerPersonalInformation;
  short* ManagerPersonalInformation_Mobius_Mark;
  Skill *SneakySkill;
  short* SneakySkill_Mobius_Mark;
  StepChosen *DistractManagerWithPhonyPhoneCallChosen;
  short *DistractManagerWithPhonyPhoneCallChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *DistractManagerWithPhonyPhoneCallWeight;
  short *DistractManagerWithPhonyPhoneCallWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  DistractManagerWithPhonyPhoneCallFailureManagerDetectsFraudStep();
  ~DistractManagerWithPhonyPhoneCallFailureManagerDetectsFraudStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // DistractManagerWithPhonyPhoneCallFailureManagerDetectsFraudStep

class DistractManagerWithPhonyPhoneCallSuccessStep : public Step {
public:

  Access *ManagerOffDuty;
  short* ManagerOffDuty_Mobius_Mark;
  Knowledge *ManagerPersonalInformation;
  short* ManagerPersonalInformation_Mobius_Mark;
  Skill *SneakySkill;
  short* SneakySkill_Mobius_Mark;
  StepChosen *DistractManagerWithPhonyPhoneCallChosen;
  short *DistractManagerWithPhonyPhoneCallChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *DistractManagerWithPhonyPhoneCallWeight;
  short *DistractManagerWithPhonyPhoneCallWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  DistractManagerWithPhonyPhoneCallSuccessStep();
  ~DistractManagerWithPhonyPhoneCallSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // DistractManagerWithPhonyPhoneCallSuccessStep

class DistractManagerWithPhonyPhoneCallFailureManagerDoesNotDetectFraudStep : public Step {
public:

  Access *ManagerOffDuty;
  short* ManagerOffDuty_Mobius_Mark;
  Knowledge *ManagerPersonalInformation;
  short* ManagerPersonalInformation_Mobius_Mark;
  Skill *SneakySkill;
  short* SneakySkill_Mobius_Mark;
  StepChosen *DistractManagerWithPhonyPhoneCallChosen;
  short *DistractManagerWithPhonyPhoneCallChosen_Mobius_Mark;
  StepWeight *WritedownaccountinformationWeight;
  short *WritedownaccountinformationWeight_Mobius_Mark;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  short *ImpersonatecustomertoobtainmoneyWeight_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short *DoNothingWeight_Mobius_Mark;
  StepWeight *DistractManagerWithPhonyPhoneCallWeight;
  short *DistractManagerWithPhonyPhoneCallWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short *MakeDecision_Mobius_Mark;
  double *TheDistributionParameters;

  DistractManagerWithPhonyPhoneCallFailureManagerDoesNotDetectFraudStep();
  ~DistractManagerWithPhonyPhoneCallFailureManagerDoesNotDetectFraudStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // DistractManagerWithPhonyPhoneCallFailureManagerDoesNotDetectFraudStep

  //List of user-specified state variables
  Access *TellerAccess;
  Access *ManagerOffDuty;
  Knowledge *CustomerInformation;
  Knowledge *InsiderKnowledge;
  Knowledge *ManagerPersonalInformation;
  Skill *SneakySkill;
  Goal *Money;
  //List of attack step weight state variables
  StepWeight *WritedownaccountinformationWeight;
  StepWeight *ImpersonatecustomertoobtainmoneyWeight;
  StepWeight *DoNothingWeight;
  StepWeight *DistractManagerWithPhonyPhoneCallWeight;
  //List of attack step chosen state variables
  StepChosen *WritedownaccountinformationChosen;
  StepChosen *ImpersonatecustomertoobtainmoneyChosen;
  StepChosen *DoNothingChosen;
  StepChosen *DistractManagerWithPhonyPhoneCallChosen;
  //List of attack steps
  WritedownaccountinformationSuccessStep WritedownaccountinformationSuccess;
  ImpersonatecustomertoobtainmoneyFailureStep ImpersonatecustomertoobtainmoneyFailure;
  ImpersonatecustomertoobtainmoneySuccessStep ImpersonatecustomertoobtainmoneySuccess;
  DoNothingOutcome1Step DoNothingOutcome1;
  DistractManagerWithPhonyPhoneCallFailureManagerDetectsFraudStep DistractManagerWithPhonyPhoneCallFailureManagerDetectsFraud;
  DistractManagerWithPhonyPhoneCallSuccessStep DistractManagerWithPhonyPhoneCallSuccess;
  DistractManagerWithPhonyPhoneCallFailureManagerDoesNotDetectFraudStep DistractManagerWithPhonyPhoneCallFailureManagerDoesNotDetectFraud;
  WritedownaccountinformationAdversaryDecision WritedownaccountinformationAD;
  ImpersonatecustomertoobtainmoneyAdversaryDecision ImpersonatecustomertoobtainmoneyAD;
  DoNothingAdversaryDecision DoNothingAD;
  DistractManagerWithPhonyPhoneCallAdversaryDecision DistractManagerWithPhonyPhoneCallAD;
  //Groups for attack steps
  PreselectGroup ImmediateGroup;
  PostselectGroup ImpersonatecustomertoobtainmoneyGroup;
  PostselectGroup DistractManagerWithPhonyPhoneCallGroup;
  PostselectGroup AdversaryDecisionGroup;
  robbery3ADVISE();
  ~robbery3ADVISE();
  void assignSVsToAttackSteps();
  double convertCostToUtility(double cost);
  double convertDetectionToUtility(double detections);
  double convertPayoffToUtility(double payoff);
  void customInitialization();

protected:
}; // end robbery3ADVISE

#endif // robbery3ADVISE_H_
