

// This C++ file was created by SanEditor

#include "Atomic/robbery3Manager/robbery3ManagerSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         robbery3ManagerSAN Constructor             
******************************************************************/


robbery3ManagerSAN::robbery3ManagerSAN(){


  Activity* InitialActionList[2]={
    &rest, //0
    &work  // 1
  };

  BaseGroupClass* InitialGroupList[2]={
    (BaseGroupClass*) &(rest), 
    (BaseGroupClass*) &(work)
  };

  managerOffDuty = new Place("managerOffDuty" ,0);
  managerOnDuty = new Place("managerOnDuty" ,1);
  BaseStateVariableClass* InitialPlaces[2]={
    managerOffDuty,  // 0
    managerOnDuty   // 1
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("robbery3Manager", 2, InitialPlaces, 
                        0, InitialROPlaces, 
                        2, InitialActionList, 2, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[4][2]={ 
    {1,0}, {0,0}, {1,1}, {0,1}
  };
  for(int n=0;n<4;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[2][2]={ 
    {0,0}, {1,1}
  };
  for(int n=0;n<2;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<2;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void robbery3ManagerSAN::CustomInitialization() {

}
robbery3ManagerSAN::~robbery3ManagerSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void robbery3ManagerSAN::assignPlacesToActivitiesInst(){
}
void robbery3ManagerSAN::assignPlacesToActivitiesTimed(){
  rest.managerOffDuty = (Place*) LocalStateVariables[0];
  rest.managerOnDuty = (Place*) LocalStateVariables[1];
  work.managerOnDuty = (Place*) LocalStateVariables[1];
  work.managerOffDuty = (Place*) LocalStateVariables[0];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================restActivity========================*/

robbery3ManagerSAN::restActivity::restActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("rest",0,Deterministic, RaceEnabled, 2,1, false);
}

robbery3ManagerSAN::restActivity::~restActivity(){
  delete[] TheDistributionParameters;
}

void robbery3ManagerSAN::restActivity::LinkVariables(){
  managerOffDuty->Register(&managerOffDuty_Mobius_Mark);
  managerOnDuty->Register(&managerOnDuty_Mobius_Mark);
}

bool robbery3ManagerSAN::restActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((managerOffDuty->Mark() > 0));
  return NewEnabled;
}

double robbery3ManagerSAN::restActivity::DeterministicParamValue(){
  return 14;
  return 1.0;  // default rate if none is specified
}

double robbery3ManagerSAN::restActivity::Weight(){ 
  return 1;
}

bool robbery3ManagerSAN::restActivity::ReactivationPredicate(){ 
  return false;
}

bool robbery3ManagerSAN::restActivity::ReactivationFunction(){ 
  return false;
}

double robbery3ManagerSAN::restActivity::SampleDistribution(){
  return 14;
}

double* robbery3ManagerSAN::restActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int robbery3ManagerSAN::restActivity::Rank(){
  return 1;
}

BaseActionClass* robbery3ManagerSAN::restActivity::Fire(){
  managerOffDuty->Mark() = 0; managerOnDuty->Mark() = 0;
  (*(managerOnDuty_Mobius_Mark))++;
  return this;
}

/*======================workActivity========================*/

robbery3ManagerSAN::workActivity::workActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("work",1,Deterministic, RaceEnabled, 2,1, false);
}

robbery3ManagerSAN::workActivity::~workActivity(){
  delete[] TheDistributionParameters;
}

void robbery3ManagerSAN::workActivity::LinkVariables(){
  managerOnDuty->Register(&managerOnDuty_Mobius_Mark);
  managerOffDuty->Register(&managerOffDuty_Mobius_Mark);
}

bool robbery3ManagerSAN::workActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(managerOnDuty_Mobius_Mark)) >=1));
  return NewEnabled;
}

double robbery3ManagerSAN::workActivity::DeterministicParamValue(){
  return 10;
  return 1.0;  // default rate if none is specified
}

double robbery3ManagerSAN::workActivity::Weight(){ 
  return 1;
}

bool robbery3ManagerSAN::workActivity::ReactivationPredicate(){ 
  return false;
}

bool robbery3ManagerSAN::workActivity::ReactivationFunction(){ 
  return false;
}

double robbery3ManagerSAN::workActivity::SampleDistribution(){
  return 10;
}

double* robbery3ManagerSAN::workActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int robbery3ManagerSAN::workActivity::Rank(){
  return 1;
}

BaseActionClass* robbery3ManagerSAN::workActivity::Fire(){
  (*(managerOnDuty_Mobius_Mark))--;
  (*(managerOffDuty_Mobius_Mark))++;
  return this;
}

