#ifndef robbery3ManagerSAN_H_
#define robbery3ManagerSAN_H_

#include "BaseClasses/EmptyGroup.h"
#include "BaseClasses/GlobalVariables.h"
#include "BaseClasses/PreselectGroup.h"
#include "BaseClasses/PostselectGroup.h"
#include "BaseClasses/state/StructStateVariable.h"
#include "BaseClasses/state/ArrayStateVariable.h"
#include "BaseClasses/SAN/SANModel.h" 
#include "BaseClasses/SAN/Place.h"
#include "BaseClasses/SAN/ExtendedPlace.h"
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               robbery3ManagerSAN Submodel Definition                   
*********************************************************************/

class robbery3ManagerSAN:public SANModel{
public:

class restActivity:public Activity {
public:

  Place* managerOffDuty;
  short* managerOffDuty_Mobius_Mark;
  Place* managerOnDuty;
  short* managerOnDuty_Mobius_Mark;

  double* TheDistributionParameters;
  restActivity();
  ~restActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // restActivityActivity

class workActivity:public Activity {
public:

  Place* managerOnDuty;
  short* managerOnDuty_Mobius_Mark;
  Place* managerOffDuty;
  short* managerOffDuty_Mobius_Mark;

  double* TheDistributionParameters;
  workActivity();
  ~workActivity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // workActivityActivity

  //List of user-specified place names
  Place* managerOffDuty;
  Place* managerOnDuty;

  // Create instances of all actvities
  restActivity rest;
  workActivity work;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;

  robbery3ManagerSAN();
  ~robbery3ManagerSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end robbery3ManagerSAN

#endif // robbery3ManagerSAN_H_
