#include "robberyRMPVNodes.h"

robberyRMPV0Worker::robberyRMPV0Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&robbery);
}

robberyRMPV0Worker::~robberyRMPV0Worker() {
  delete [] TheModelPtr;
}

double robberyRMPV0Worker::Reward_Function(void) {

return robbery->InsiderKnowledge->Mark();

return (0);



}

robberyRMPV0::robberyRMPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TherobberyADVISE);
  double startpts[13]={0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0};
  double stoppts[13]={0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0};
  Initialize("k_insider",(RewardType)0,13, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("InsiderKnowledge","robbery");
}

robberyRMPV0::~robberyRMPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void robberyRMPV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new robberyRMPV0Worker;
}
robberyRMPV1Worker::robberyRMPV1Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&robbery);
}

robberyRMPV1Worker::~robberyRMPV1Worker() {
  delete [] TheModelPtr;
}

double robberyRMPV1Worker::Reward_Function(void) {

return robbery->CustomerInformation->Mark();

return (0);



}

robberyRMPV1::robberyRMPV1(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TherobberyADVISE);
  double startpts[13]={0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0};
  double stoppts[13]={0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0};
  Initialize("k_custinfo",(RewardType)0,13, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("CustomerInformation","robbery");
}

robberyRMPV1::~robberyRMPV1() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void robberyRMPV1::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new robberyRMPV1Worker;
}
robberyRMPV2Worker::robberyRMPV2Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&robbery);
}

robberyRMPV2Worker::~robberyRMPV2Worker() {
  delete [] TheModelPtr;
}

double robberyRMPV2Worker::Reward_Function(void) {

return robbery->Money->Mark();

return (0);



}

robberyRMPV2::robberyRMPV2(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TherobberyADVISE);
  double startpts[13]={0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0};
  double stoppts[13]={0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0};
  Initialize("g_money",(RewardType)0,13, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("Money","robbery");
}

robberyRMPV2::~robberyRMPV2() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void robberyRMPV2::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new robberyRMPV2Worker;
}
