#include "robberyRM2PVNodes.h"

robberyRM2PV0Worker::robberyRM2PV0Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&robbery2);
}

robberyRM2PV0Worker::~robberyRM2PV0Worker() {
  delete [] TheModelPtr;
}

double robberyRM2PV0Worker::Reward_Function(void) {

return robbery2->InsiderKnowledge->Mark();

return (0);



}

robberyRM2PV0::robberyRM2PV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&Therobbery2ADVISE);
  double startpts[13]={0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0};
  double stoppts[13]={0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0};
  Initialize("k_insider",(RewardType)0,13, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("InsiderKnowledge","robbery2");
}

robberyRM2PV0::~robberyRM2PV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void robberyRM2PV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new robberyRM2PV0Worker;
}
robberyRM2PV1Worker::robberyRM2PV1Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&robbery2);
}

robberyRM2PV1Worker::~robberyRM2PV1Worker() {
  delete [] TheModelPtr;
}

double robberyRM2PV1Worker::Reward_Function(void) {

return robbery2->CustomerInformation->Mark();

return (0);



}

robberyRM2PV1::robberyRM2PV1(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&Therobbery2ADVISE);
  double startpts[13]={0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0};
  double stoppts[13]={0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0};
  Initialize("k_custinfo",(RewardType)0,13, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("CustomerInformation","robbery2");
}

robberyRM2PV1::~robberyRM2PV1() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void robberyRM2PV1::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new robberyRM2PV1Worker;
}
robberyRM2PV2Worker::robberyRM2PV2Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&robbery2);
}

robberyRM2PV2Worker::~robberyRM2PV2Worker() {
  delete [] TheModelPtr;
}

double robberyRM2PV2Worker::Reward_Function(void) {

return robbery2->Money->Mark();

return (0);



}

robberyRM2PV2::robberyRM2PV2(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&Therobbery2ADVISE);
  double startpts[13]={0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0};
  double stoppts[13]={0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 30.0, 35.0, 40.0, 45.0, 50.0, 55.0, 60.0};
  Initialize("g_money",(RewardType)0,13, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("Money","robbery2");
}

robberyRM2PV2::~robberyRM2PV2() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void robberyRM2PV2::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new robberyRM2PV2Worker;
}
